__gnu_pbds::detail::trie_policy_base< Node_CItr, Node_Itr, _ATraits, _Alloc >(3cxx)

NAME
__gnu_pbds::detail::trie_policy_base< Node_CItr, Node_Itr, _ATraits, _Alloc > - Base class for trie policies.

SYNOPSIS

Inherits __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >.

Inherited by __gnu_pbds::trie_order_statistics_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc > [private], and __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc > [private].

  Public Types

typedef _ATraits access_traits
typedef _Alloc allocator_type
typedef node_const_iterator::value_type const_iterator
typedef node_iterator::value_type iterator
typedef base_type::key_const_reference key_const_reference
typedef base_type::key_type key_type
typedef null_type metadata_type
typedef Node_CItr node_const_iterator
typedef Node_Itr node_iterator
typedef allocator_type::size_type size_type

  Protected Types

typedef rebind_v::const_pointer const_pointer
typedef rebind_v::const_reference const_reference
typedef Node_Itr::value_type it_type
typedef remove_const< key_type >::type rckey_type
typedef remove_const< value_type >::type rcvalue_type
typedef rebind_traits< _Alloc, rckey_type > rebind_k
typedef rebind_traits< _Alloc, rcvalue_type > rebind_v
typedef rebind_v::reference reference
typedef std::iterator_traits< it_type >::value_type value_type

  Protected Member Functions

virtual const_iterator end () const =0
virtual iterator end ()=0
it_type end_iterator () const
virtual const access_traits & get_access_traits () const =0
virtual node_const_iterator node_begin () const =0
virtual node_iterator node_begin ()=0
virtual node_const_iterator node_end () const =0
virtual node_iterator node_end ()=0

  Static Protected Member Functions

static size_type common_prefix_len (node_iterator, e_const_iterator, e_const_iterator, const access_traits &)
static key_const_reference extract_key (const_reference r_val)
static iterator leftmost_it (node_iterator)
static bool less (e_const_iterator, e_const_iterator, e_const_iterator, e_const_iterator, const access_traits &)
static iterator rightmost_it (node_iterator)

Detailed Description

  template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>
class __gnu_pbds::detail::trie_policy_base< Node_CItr, Node_Itr, _ATraits, _Alloc >" Base class for trie policies.

Author

Generated automatically by Doxygen for libstdc++ from the source code.